function init()
	RegisterTool("overkill", "OVERKILL", "MOD/vox/overkill.vox", 1)
	SetBool("game.tool.overkill.enabled", true)
	SetFloat("game.tool.overkill.ammo", 101)
	
	slappower = GetFloat("savegame.mod.slappower")
	if slappower == 0 then slappower = 500 end
	swingTimer = 0.1

	line = {}
	line.active = false
	damage = 0.7
	hitsound = LoadSound("MOD/snd/hitsound2.ogg")
	nomario = LoadSound("MOD/snd/nomario.ogg")
end


function Slap()
	local forwardPos = TransformToParentPoint(GetCameraTransform(), Vec(0, 0, -1))
	local direction = VecSub(forwardPos, GetCameraTransform().pos)
	QueryRequire("physical dynamic")
	local hit, dist, normal, shape = QueryRaycast(GetCameraTransform().pos, direction, 3)
	if hit then
		if GetBool("savegame.mod.overkill.sound") then
			PlaySound(hitsound, GetPlayerTransform().pos, 2)--, false)
		else
			PlaySound(nomario, GetPlayerTransform().pos, 2)
		end
		
		local body = GetShapeBody(shape)
		if IsBodyDynamic(body) then
			local mass = GetBodyMass(body)
			local scale = mass > 1000 and slappower/1.25 or slappower*3.25
			local vel = VecScale(direction, 0.5)
			vel = VecScale(vel, scale)
			SetBodyVelocity(body, vel)
			MakeHole(VecAdd(GetCameraTransform().pos, VecScale(direction, dist)), damage*1, damage*1, damage*1)
		end
	end
	swingTimer = 0.1
end


function tick(dt)
	if GetString("game.player.tool") == "overkill" and GetPlayerVehicle() == 0 then
		if InputPressed("lmb") then
			Slap()
		end


		local b = GetToolBody()
		if b ~= 0 then
			local offset = Transform(Vec(0, 0, 0), QuatEuler(0, 0, 0))
			SetToolTransform(offset)

			if swingTimer > 0 then
				local t = Transform()
				t.pos = Vec(0, 0, -swingTimer*3)
				t.rot = QuatEuler(swingTimer*0, swingTimer*300, 0)
				SetToolTransform(t)

				swingTimer = swingTimer - dt
			end
		end
	end
end
